package chatexample;

import chat.*;
import tuplespaces.*;

public class ChatExample {
    public static void main(String[] args) {
	TupleSpace ts=new LocalTupleSpace();
	ChatServer cs=new ChatServer(ts, 3, new String[] {"Foo", "Bar"});
	
	cs.writeMessage("Foo", "Hello world");
	cs.writeMessage("Bar", "Hello universe");
	cs.writeMessage("Bar", "Hello world");
	cs.writeMessage("Bar", "Hello");
	cs.writeMessage("Bar", "Hello again");
	
	ChatListener cl=cs.openConnection("Bar");
	
	expect(cl, "Hello world");
	expect(cl, "Hello");
	expect(cl, "Hello again");
	cl.closeConnection();
	System.err.println("No obvious chat interface problems found.");
    }

    public static void expect(ChatListener cl, String s) {
	String g=cl.getNextMessage();

	if (!s.equals(g)) {
	    System.err.println("Unexpected message.");
	    System.err.println("Expected: "+s);
	    System.err.println("Got:      "+g);
	    System.exit(1);
	}	    
    }
}
